Imports Microsoft.VisualBasic.FileIO
Imports System.IO
Imports System.Text.RegularExpressions
Public Class MainForm
    Dim myLogs() As LogNode
    Dim rootLogs As New List(Of LogNode)
    Dim outputLogs As New List(Of LogNode)

    Private Sub GetNodesList()
        Dim basepath As String = Me.ReadFolderPath.Text
        Dim maxlogno As Integer = CInt(Me.MaxLogNo.Text)
        ReDim myLogs(maxlogno)
        rootLogs.Clear()
        outputLogs.Clear()

        'wf̑SOt@C[v
        'GetFiles(basepath, True, "*.log")͎gȂB\Ȃt@C𕴂ꍞ܂Ȃ߁B

        For logno As Integer = 0 To maxlogno
            Dim folderno As Integer = CInt(Int(logno / 200))
            Dim readfilepath As String = basepath & "\sd" & folderno & "\" & logno & ".log"
            Dim fields(17) As String
            myLogs(logno) = New LogNode
            If My.Computer.FileSystem.FileExists(readfilepath) Then
                'eOt@Cǂݍ
                fields = GetLogFields(readfilepath)

                Dim mylog As New LogNode
                With myLogs(logno)
                    Dim sd As String = fields(0)
                    sd = Mid(sd, 1, 4) & "/" & Mid(sd, 5, 2) & "/" & Mid(sd, 7, 2) & " " & Mid(sd, 10, 2) & ":" & Mid(sd, 12, 2) & ":" & Mid(sd, 14, 2)
                    .PostDate = sd
                    .UserName = fields(2)
                    .Subject = fields(3)
                    .Email = ""
                    .Comment = fields(4)
                    .ID = CInt(Mid(fields(12), 2, InStr(fields(12), "]") - 2))
                    .PID = CInt(Mid(fields(12), InStr(fields(12), "]") + 1, 3))
                    .AttachFileName = fields(16)
                    If .PID > 0 Then
                        'eIDĂ΁AeNodeChildAdd
                        myLogs(.PID).ChildNodes.Add(myLogs(logno))
                    Else
                        'eIDĂȂ΁ArootLogsAdd
                        rootLogs.Add(myLogs(logno))
                    End If
                End With
            End If
        Next
    End Sub
    Private Sub ExecJoinNoResLogs()
        'XȂOȂmylog0𐶐AchildȂlogsׂmylog0ɒǉAmylog0ƂȊOoutputlogɒǉ
        Dim rootno As Integer = myLogs.Length
        ReDim Preserve myLogs(rootno)
        myLogs(rootno) = New LogNode
        With myLogs(rootno)
            .ID = rootno
            .PID = 0
            .Subject = "̑̋L"
            .Comment = "̑̋L܂Ƃ߂Ă܂B"
            .UserName = "Ǘl"
            .AttachFileName = ""
            .Email = ""
        End With

        For Each rootlog As LogNode In rootLogs
            If rootlog.ChildNodes.Count = 0 Then
                If myLogs(rootno).ChildNodes.Count = 0 Then
                    myLogs(rootno).PostDate = rootlog.PostDate
                End If
                myLogs(rootno).ChildNodes.Add(rootlog)
                rootlog.PID = rootno
            Else
                outputLogs.Add(rootlog)
            End If
        Next
        If myLogs(rootno).ChildNodes.Count > 0 Then
            outputLogs.Add(myLogs(rootno))
        Else
            myLogs(rootno) = Nothing
        End If
    End Sub
    Private Sub ExecJoinAllLogs()
        'SOȂmylog0𐶐ARootLogsׂmylog0ɒǉAoutputlogmylog0ǉ
        Dim rootno As Integer = myLogs.Length
        ReDim Preserve myLogs(rootno)
        myLogs(rootno) = New LogNode

        With myLogs(rootno)
            .ID = rootno
            .PID = 0
            .Subject = "ׂĂ̋L"
            .Comment = "ׂĂ̋L܂Ƃ߂Ă܂B"
            .UserName = "Ǘl"
            .AttachFileName = ""
            .Email = ""
        End With

        For Each rootlog As LogNode In rootLogs
            If myLogs(rootno).ChildNodes.Count = 0 Then
                myLogs(rootno).PostDate = rootlog.PostDate
            End If
            myLogs(rootno).ChildNodes.Add(rootlog)
            rootlog.PID = rootno
        Next

        If myLogs(rootno).ChildNodes.Count > 0 Then
            outputLogs.Add(myLogs(rootno))
        Else
            myLogs(rootno) = Nothing
        End If

    End Sub
    Private Sub ExecAddRootLog()
        Dim templogs As New List(Of LogNode)
        For Each rootlog As LogNode In outputLogs
            Dim rootno As Integer = myLogs.Length
            ReDim Preserve myLogs(rootno)
            myLogs(rootno) = New LogNode

            With myLogs(rootno)
                .ID = rootno
                .PID = 0
                .PostDate = rootlog.PostDate
                .Subject = rootlog.Subject
                .Comment = ""
                .UserName = "Ǘl"
                .AttachFileName = ""
                .Email = ""
            End With

            myLogs(rootno).ChildNodes.Add(rootlog)
            rootlog.PID = rootno
            templogs.Add(myLogs(rootno))
        Next
        outputLogs = templogs
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartConvert.Click
        '܂VvȃOc[B
        'ׂĂ̒ł邱Ƃł邪AƂ̂ƂlƏʂɂĒǂق
        GetNodesList()

        If Me.JoinNoResLogs.Checked = True Then
            ExecJoinNoResLogs()
        Else
            If Me.JoinAllLogs.Checked = True Then
                ExecJoinAllLogs()
            Else
                outputLogs = rootLogs
            End If
        End If
        If Me.AddRootLog.Checked = True Then ExecAddRootLog()

        Dim exportfolder As String = ""
        Dim writefilepath As String = ""

        For Each rootlog As LogNode In outputLogs
            Dim sleadkey As String = CLng( _
                        (Date.Parse(rootlog.PostDate) - #1/1/1970#).TotalMilliseconds / 1000 _
                    ).ToString

            'Oresno>>1̂悤ɋLԍɑ΂AJ[ƂĎgpBrootĂяo0
            My.Computer.FileSystem.CreateDirectory(Me.WriteFolderPath.Text)
            Dim resno As Integer = 0

            If Me.SeparateByTree.Checked = True Then
                Dim subject As String = Regex.Replace(rootlog.Subject, "[\\\/:,;*?""<>|]", "_")
                '\ / : , ; * ? " < > |
                SeparateCopy(rootlog, sleadkey & "_" & subject)
            Else
                My.Computer.FileSystem.CreateDirectory(Me.WriteFolderPath.Text & "\dat")
                WriteLog(rootlog, sleadkey, 0)
            End If
        Next

        Me.ToolStripStatusLabel1.Text = ""
        MsgBox("I܂")
    End Sub
    Private Sub SeparateCopy(ByVal mylog As LogNode, ByVal sleadkey As String)

        Dim folderno As Integer = CInt(Int(mylog.ID / 200))

        Dim sourcefile As String = Me.ReadFolderPath.Text _
                                                & "\sd" & folderno.ToString _
                                                & "\" & mylog.ID & ".log"
        My.Computer.FileSystem.CreateDirectory( _
                                                Me.WriteFolderPath.Text _
                                                & "\" & sleadkey _
                                                & "\sd" & folderno.ToString)
        Dim targetfile As String = _
                                                Me.WriteFolderPath.Text _
                                                & "\" & sleadkey _
                                                & "\sd" & folderno.ToString _
                                                & "\" & mylog.ID & ".log"


        If File.Exists(sourcefile) Then
            Me.ToolStripStatusLabel1.Text = sourcefile & "Rs[Ă܂EEE"
            Me.Refresh()
            My.Computer.FileSystem.CopyFile(sourcefile, targetfile, True)
        End If

        If mylog.AttachFileName.Length > 0 Then
            Dim sourcefile2 As String = Me.ReadFolderPath.Text _
                                                & "\" & mylog.AttachFileName
            Dim targetfile2 As String = Me.WriteFolderPath.Text _
                                                & "\" & sleadkey _
                                                & "\" & mylog.AttachFileName
            If File.Exists(sourcefile2) Then
                Me.ToolStripStatusLabel1.Text = sourcefile2 & "Rs[Ă܂EEE"
                Me.Refresh()
                My.Computer.FileSystem.CopyFile(sourcefile2, targetfile2, True)
            End If
        End If

        For Each _mylog As LogNode In mylog.ChildNodes
            SeparateCopy(_mylog, sleadkey)
        Next
    End Sub
    Private Sub WriteLog(ByVal mylog As LogNode, ByVal sleadkey As String, ByRef resno As Integer)
        '1@O 
        '2@E-mail 
        '3@t 
        '4@{ 
        '5@^Cg 
        Dim myline As String
        myline = mylog.UserName
        myline = myline & "<>" & mylog.Email
        myline = myline & "<>" & mylog.PostDate

        resno = resno + 1 'Ăяoтresno+1
        mylog.ResNo = resno


        If mylog.AttachFileName.Length > 0 Then
            Dim filesource As String = Me.ReadFolderPath.Text & "\" & mylog.AttachFileName
            Dim filepath As String = Me.WriteFolderPath.Text _
                                    & "\img\" & sleadkey & "\" & mylog.AttachFileName
            Dim fileurl As String = Me.TargetURL.Text _
                                    & "/img/" & sleadkey & "/" & mylog.AttachFileName
            't@CRs[
            My.Computer.FileSystem.CreateDirectory(Me.WriteFolderPath.Text _
                                                    & "\img\" & sleadkey)
            If File.Exists(filesource) Then
                Me.ToolStripStatusLabel1.Text = filesource & "Rs[Ă܂EEE"
                Me.Refresh()
                My.Computer.FileSystem.CopyFile(filesource, filepath, True)
                '
                'img0ch̎dl1sڂɃt@CURL()łăt@CTCY
                myline = myline & "<>" & fileurl & " (" _
                        & CInt(My.Computer.FileSystem.GetFileInfo(filepath).Length / 1000).ToString & "KB)<br>"
            End If
        Else
            myline = myline & "<>"
        End If

        If (mylog.PID <> 0) Then
            'X悪>>1̂Ƃ
            If myLogs(mylog.PID).ResNo = 1 Then
                '[gOǉ邩ׂĂ܂Ƃ߂Ƃ>>1͕sv
                If Me.AddRootLog.Checked = False And Me.JoinAllLogs.Checked = False Then
                    'X̂ȂO܂Ƃ߂ƂŌ݂܂Ƃ߃XȂ>>1͕sv
                    If Me.JoinNoResLogs.Checked = True And mylog.PID = myLogs.Length - 1 Then
                    Else
                        myline = myline & "&gt;&gt;" & myLogs(mylog.PID).ResNo & " "
                    End If
                End If
            Else
                myline = myline & "&gt;&gt;" & myLogs(mylog.PID).ResNo & " "
            End If
        End If
        myline = myline & mylog.Subject


        myline = myline & "<br><br>" & RegexComment(mylog.Comment)

        If mylog.PID = 0 Then
            myline = myline & "<>" & mylog.Subject & vbCrLf
        Else
            myline = myline & "<>" & vbCrLf
        End If

        Dim writefilepath As String = Me.WriteFolderPath.Text & "\dat\" & sleadkey & ".dat"
        Me.ToolStripStatusLabel1.Text = writefilepath & " ł܂EEE"
        Me.Refresh()
        My.Computer.FileSystem.WriteAllText(writefilepath, myline, True, System.Text.Encoding.GetEncoding("SHIFT-JIS"))

        For Each _mylog As LogNode In mylog.ChildNodes
            WriteLog(_mylog, sleadkey, resno)
        Next
    End Sub
    Private Function RegexComment(ByVal comment As String) As String
        comment = Regex.Replace(comment, "<nobr>|</nobr>|<wbr>", "")
        '1.<!---->܂ł͍폜
        comment = Regex.Replace(comment, "<!-- .*? -->", "")
        '2.<a></a>܂ł <a href=(̕) target=...ƒu
        comment = Regex.Replace(comment, "<a href=.*?>(.*?)</a>", "$1")
        Return comment
    End Function

    Private Function GetLogFields(ByVal readfilepath As String) As String()
        Me.ToolStripStatusLabel1.Text = readfilepath & " ǂݍł܂EEE"
        Me.Refresh()
        Dim fields(17) As String
        Dim mycodes As Byte()
        '26 23 39 35 3B ̃p^[5F
        Dim mypattern As Byte() = {38, 35, 57, 53, 59}
        mycodes = My.Computer.FileSystem.ReadAllBytes(readfilepath)

        Dim msg As String = ""
        For i As Integer = 0 To mycodes.Length - 5
            msg = msg & Convert.ToString(mycodes(i), 16) & " "
            If mycodes(i) = mypattern(0) Then
                '               Dim msg As String = mycodes(i) & ":" & Chr(mycodes(i))
                For j As Integer = 1 To 4
                    '                  msg = msg & Chr(mycodes(i + j))
                    If mycodes(i + j) <> mypattern(j) Then
                        Exit For
                    Else
                        If j = 4 Then
                            mycodes(i) = 95
                            For k As Integer = 1 To 4
                                mycodes(i + k) = Nothing
                            Next
                        End If
                    End If
                Next
            End If
        Next

        Dim mychoice As New List(Of Byte)
        For i As Integer = 0 To mycodes.Length - 1
            If mycodes(i) <> Nothing Then
                mychoice.Add(mycodes(i))
            End If
        Next

        Dim mystring As String = System.Text.Encoding.GetEncoding(932).GetString(mychoice.ToArray)
        fields = mystring.Split(CChar(""""))
        Return fields
    End Function

    Private Sub ShowFolderDialog1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowFolderDialog1.Click
        Dim mydialog As New FolderBrowserDialog
        mydialog.SelectedPath = Me.ReadFolderPath.Text
        If mydialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.ReadFolderPath.Text = mydialog.SelectedPath
        End If
        mydialog.Dispose()
    End Sub

    Private Sub ShowFolderDialog2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowFolderDialog2.Click
        Dim mydialog As New FolderBrowserDialog
        mydialog.SelectedPath = Me.WriteFolderPath.Text
        If mydialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.WriteFolderPath.Text = mydialog.SelectedPath
        End If
        mydialog.Dispose()
    End Sub

    Private Sub ReadFolderPath_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadFolderPath.TextChanged
        Dim files As String() = Directory.GetFiles(ReadFolderPath.Text, "*.log", IO.SearchOption.AllDirectories)
        Dim no1 As Long = 0
        Dim no2 As Long = 0
        For Each file As String In files

            Dim result As String = Regex.Match(Path.GetFileNameWithoutExtension(file), "^\d{1,5}$").ToString
            If IsNumeric(result) Then
                no1 = CInt(result)
                If no1 > no2 Then no2 = no1
            End If
        Next
        Me.MaxLogNo.Text = no2.ToString
        My.Settings.ReadFolderPath = ReadFolderPath.Text
        My.Settings.Save()
    End Sub

    Private Sub WriteFolderPath_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteFolderPath.TextChanged
        My.Settings.WriteFolderPath = WriteFolderPath.Text
        My.Settings.Save()
    End Sub

    Private Sub TargetURL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TargetURL.TextChanged
        My.Settings.TargetURL = TargetURL.Text
        My.Settings.Save()
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.WriteFolderPath.Text = My.Settings.WriteFolderPath
        Me.ReadFolderPath.Text = My.Settings.ReadFolderPath
        Me.TargetURL.Text = My.Settings.TargetURL
    End Sub

    Private Sub OptionConbination(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles SeparateByTree.CheckedChanged _
                , JoinAllLogs.CheckedChanged _
                , JoinNoResLogs.CheckedChanged _
                , AddRootLog.CheckedChanged
        'uSOvȂuXOv͖Ӗ
        'uc[ʂɕvȂuSOv͎gȂ
        'uc[ʂɕvȂu[gOǉv͈ӖȂ
        'ȂɂuXOvɂ́u[gOǉvق
        If SeparateByTree.Checked = True Then
            Me.AddRootLog.Checked = False
            Me.AddRootLog.Enabled = False
            Me.JoinAllLogs.Checked = False
            Me.JoinAllLogs.Enabled = False
            Me.TargetURL.Enabled = False
        Else
            Me.AddRootLog.Enabled = True
            Me.JoinAllLogs.Enabled = True
            Me.TargetURL.Enabled = True

            If Me.JoinNoResLogs.Checked = True Then
                Me.JoinAllLogs.Checked = False
                Me.JoinAllLogs.Enabled = False
            Else
                Me.JoinAllLogs.Enabled = True
            End If
            If Me.JoinAllLogs.Checked = True Then
                Me.AddRootLog.Checked = False
                Me.AddRootLog.Enabled = False
                Me.JoinNoResLogs.Checked = False
                Me.JoinNoResLogs.Enabled = False
            Else
                Me.AddRootLog.Enabled = True
                Me.JoinNoResLogs.Enabled = True
            End If

            If Me.AddRootLog.Checked = True Then
                Me.JoinAllLogs.Checked = False
                Me.JoinAllLogs.Enabled = False
            Else
                Me.JoinAllLogs.Enabled = True
            End If
        End If
    End Sub

    Private Sub SiteURL_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles SiteURL.LinkClicked
        'LinkLabel̎g͖{Ȃ̂ŒӁB蔲B
        System.Diagnostics.Process.Start(Me.SiteURL.Text.ToString)
    End Sub
End Class
Public Class LogNode
    Private _id As Integer
    Public Property ID() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            _id = value
        End Set
    End Property
    Private _pid As Integer
    Public Property PID() As Integer
        Get
            Return _pid
        End Get
        Set(ByVal value As Integer)
            _pid = value
        End Set
    End Property
    Private _postdate As String
    Public Property PostDate() As String
        Get
            Return _postdate
        End Get
        Set(ByVal value As String)
            _postdate = value
        End Set
    End Property
    Private _username As String
    Public Property UserName() As String
        Get
            Return _username
        End Get
        Set(ByVal value As String)
            _username = value
        End Set
    End Property
    Private _email As String
    Public Property Email() As String
        Get
            Return _email
        End Get
        Set(ByVal value As String)
            _email = value
        End Set
    End Property
    Private _subject As String
    Public Property Subject() As String
        Get
            Return _subject
        End Get
        Set(ByVal value As String)
            _subject = value
        End Set
    End Property
    Private _comment As String
    Public Property Comment() As String
        Get
            Return _comment
        End Get
        Set(ByVal value As String)
            _comment = value
        End Set
    End Property
    Private _attachfilename As String
    Public Property AttachFileName() As String
        Get
            Return _attachfilename
        End Get
        Set(ByVal value As String)
            _attachfilename = value
        End Set
    End Property
    Private _childnodes As New List(Of LogNode)
    Public Property ChildNodes() As List(Of LogNode)
        Get
            Return _childnodes
        End Get
        Set(ByVal value As List(Of LogNode))
            _childnodes = value
        End Set
    End Property
    Private _resno As Integer
    Public Property ResNo() As Integer
        Get
            Return _resno
        End Get
        Set(ByVal value As Integer)
            _resno = value
        End Set
    End Property

End Class